"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mDNSSearch = void 0;
const mDnsSd = require('node-dns-sd');
class mDNSSearch {
    constructor() {
    }
    search(timeout, returnOnFirstFound = false) {
        return mDnsSd.discover({
            name: '_hue._tcp.local',
            wait: timeout ? timeout / 1000 : 3,
            quick: returnOnFirstFound
        }).then((devices) => {
            let results = [];
            if (devices && devices.length > 0) {
                devices.forEach((device) => {
                    results.push({
                        internalipaddress: device.address,
                        id: device.fqdn
                    });
                });
            }
            return results;
        });
    }
}
exports.mDNSSearch = mDNSSearch;
